#
# Copyright (c) 1989, 2020, Oracle and/or its affiliates.
#

#
# Definitions common to command source.
#
# include global definitions; SRC should be defined in the shell.
# SRC is needed until RFE 1026993 is implemented.

include $(SRC)/Makefile.master
include $(SRC)/Makefile.progs
include $(SRC)/Makefile.smf

KRB5DIR=	$(ROOT)/usr
STUBKRB5DIR=	$(STUBROOT)/usr
KRB5LIB=	$(KRB5DIR)/lib/krb5
STUBKRB5LIB=	$(STUBKRB5DIR)/lib/krb5
PROTO_KRB5LIB=	usr/lib/krb5

ROOTBIN=		$(ROOT)/usr/bin
ROOTLIB=		$(ROOT)/usr/lib
ROOTLIBFS=		$(ROOTLIB)/fs
STUBROOTLIB=		$(STUBROOT)/usr/lib
ROOTLIBZONES=		$(ROOT)/lib/zones

ROOTSHLIB=	$(ROOT)/usr/share/lib
ROOTPKGBIN=	$(ROOT)/usr/sadm/install/bin
ROOTCLASS_SCR_DIR= $(ROOT)/usr/sadm/install/scripts
ROOTADMIN_SRC_DIR= $(ROOT)/var/sadm/install/admin

ROOTSHLIBCCS=	$(ROOTSHLIB)/ccs
ROOTUSRSBIN=	$(ROOT)/usr/sbin
ROOTETC=	$(ROOT)/etc

ROOTETCSECURITY=	$(ROOTETC)/security
ROOTETCTSOL=	$(ROOTETCSECURITY)/tsol
ROOTETCSECLIB=	$(ROOTETCSECURITY)/lib
ROOTAUTHATTRD=	$(ROOTETCSECURITY)/auth_attr.d
ROOTEXECATTRD=	$(ROOTETCSECURITY)/exec_attr.d
ROOTPROFATTRD=	$(ROOTETCSECURITY)/prof_attr.d
ROOTUSERATTRD=	$(ROOTETC)/user_attr.d
ROOTETCZONES=	$(ROOTETC)/zones

ROOTETCINET=	$(ROOT)/etc/inet
ROOTUSRKVM=	$(ROOT)/usr/kvm
ROOTSUNOS=	$(ROOT)/usr/sunos
ROOTSUNOSBIN=	$(ROOT)/usr/sunos/bin
ROOTSUNOSLIB=	$(ROOT)/usr/sunos/lib
ROOTXPG4=	$(ROOT)/usr/xpg4
ROOTXPG4BIN=	$(ROOT)/usr/xpg4/bin
ROOTXPG4BIN32=	$(ROOTXPG4BIN)/$(MACH32)
ROOTXPG4BIN64=	$(ROOTXPG4BIN)/$(MACH64)
ROOTXPG6=	$(ROOT)/usr/xpg6
ROOTXPG6BIN=	$(ROOT)/usr/xpg6/bin
ROOTXPG7=	$(ROOT)/usr/xpg7
ROOTXPG7BIN=	$(ROOT)/usr/xpg7/bin
ROOTLOCALEDEF=	$(ROOT)/usr/lib/localedef
ROOTCHARMAP=	$(ROOTLOCALEDEF)/charmap
ROOTI18NEXT=	$(ROOTLOCALEDEF)/extensions
ROOTI18NEXT64=	$(ROOTLOCALEDEF)/extensions/$(MACH64)
ROOTBIN32=	$(ROOTBIN)/$(MACH32)
ROOTBIN64=	$(ROOTBIN)/$(MACH64)
ROOTCMDDIR64=	$(ROOTCMDDIR)/$(MACH64)
ROOTLIB64=	$(ROOTLIB)/$(MACH64)
ROOTUSRSBIN32=	$(ROOTUSRSBIN)/$(MACH32)
ROOTUSRSBIN64=	$(ROOTUSRSBIN)/$(MACH64)

ROOTMAN=	$(ROOT)/usr/share/man
ROOTMAN3=	$(ROOTMAN)/man3
ROOTMAN5=	$(ROOTMAN)/man5
ROOTMAN8=	$(ROOTMAN)/man8

ROOTVARSMB=	$(ROOT)/var/smb

ROOTADMINBIN=			$(ROOT)/usr/snadm/bin

ROOTUSRLIBINSTALLADM=		$(ROOT)/usr/lib/installadm
ROOTUSRLIBINSTALL=		$(ROOT)/usr/lib/install
ROOTVARAIWEB=			$(ROOT)/var/ai/ai-webserver
ROOTVARAIWEBCONF=		$(ROOT)/var/ai/ai-webserver/conf.d
ROOTVARAISVC=			$(ROOT)/var/ai/service/.conf-templ
ROOTVARAITELEMETRY=		$(ROOT)/var/ai/telemetry
ROOTVARAICGI=			$(ROOT)/var/ai/image-server/cgi-bin
ROOTVARAIDOCROOT=		$(ROOT)/var/ai/image-server/images
ROOTVARAIWIZARDCSS=		$(ROOT)/var/ai/image-server/images/css
ROOTVARAIWIZARDIMAGE=		$(ROOT)/var/ai/image-server/images/image
ROOTVARAIWIZARDSCRIPT=		$(ROOT)/var/ai/image-server/images/script
ROOTVARAIWIZARDSERVERSIDE=	$(ROOT)/var/ai/image-server/images/server-side

ROOTVARWEBUICONF=		$(ROOT)/var/webui/conf
ROOTVARWEBUICONFD=		$(ROOT)/var/webui/conf/conf.d
ROOTUSRLIBWEBUI=		$(ROOT)/usr/lib/webui
ROOTUSRLIBWEBUIWSGI=		$(ROOTUSRLIBWEBUI)/wsgi
ROOTUSRLIBWEBUIWSGICOORD=	$(ROOTUSRLIBWEBUIWSGI)/coord
ROOTUSRLIBWEBUIANALYTICS=	$(ROOTUSRLIBWEBUI)/analytics
ROOTUSRLIBWEBUIANALYTICSCHARTS=	$(ROOTUSRLIBWEBUI)/analytics/charts
ROOTUSRLIBWEBUIANALYTICSCHARTSVENDOR= $(ROOTUSRLIBWEBUI)/analytics/charts/vendor
ROOTUSRLIBWEBUIBIN=		$(ROOTUSRLIBWEBUI)/bin
ROOTUSRLIBWEBUIDOCROOT=		$(ROOTUSRLIBWEBUI)/htdocs
ROOTUSRLIBWEBUIJS=		$(ROOTUSRLIBWEBUIDOCROOT)/js
ROOTUSRLIBWEBUISOLARIS=		$(ROOTUSRLIBWEBUIDOCROOT)/solaris
ROOTUSRLIBWEBUISOLARISAPPS=	$(ROOTUSRLIBWEBUISOLARIS)/apps
ROOTUSRLIBWEBUISOLARISCSS=	$(ROOTUSRLIBWEBUISOLARIS)/css
ROOTUSRLIBWEBUISOLARISDATA=	$(ROOTUSRLIBWEBUISOLARIS)/data
ROOTUSRLIBWEBUISOLARISDASHBOARD= $(ROOTUSRLIBWEBUISOLARISAPPS)/dashboard
ROOTUSRLIBWEBUISOLARISDOCS=	$(ROOTUSRLIBWEBUISOLARISAPPS)/docs
ROOTUSRLIBWEBUISOLARISIMAGES=	$(ROOTUSRLIBWEBUISOLARIS)/images
ROOTUSRLIBWEBUISOLARISLOGIN=	$(ROOTUSRLIBWEBUISOLARIS)/login
ROOTUSRLIBWEBUISOLARISLOGINCSS=	$(ROOTUSRLIBWEBUISOLARISLOGIN)/css
ROOTUSRLIBWEBUISOLARISPREFS=	$(ROOTUSRLIBWEBUISOLARIS)/preferences
ROOTUSRLIBWEBUISOLARISTESTS=	$(ROOTUSRLIBWEBUISOLARIS)/tests
ROOTUSRLIBWEBUISOLARISWEBUI=	$(ROOTUSRLIBWEBUISOLARIS)/webui

ROOTSHLIBJS=			$(ROOTSHLIB)/javascript
ROOTSHLIBJSJET=			$(ROOTSHLIBJS)/jet

ROOTAUTOINST=			$(ROOT)/usr/share/auto_install
ROOTAUTOINSTMANIFEST=		$(ROOTAUTOINST)/manifest
ROOTAUTOINSTMANIFESTEDITOR=	$(ROOTAUTOINSTMANIFEST)/editor
ROOTAUTOINSTSCPROFILES=		$(ROOTAUTOINST)/sc_profiles
ROOTAUTOINSTCLEANUPARCHIVE=	$(ROOTAUTOINSTSCPROFILES)/cleanup_archive
ROOTAUTOINSTINSTALLENV=		$(ROOTAUTOINSTSCPROFILES)/install_env
ROOTDISTROCONST=		$(ROOT)/usr/share/distro_const
ROOTDISTROCONSTPROFILE=		$(ROOTDISTROCONST)/profile
ROOTDISTROCONSTSORT=		$(ROOTDISTROCONST)/sort
ROOTUSRSHAREJSON=		$(ROOT)/usr/share/lib/json
ROOTUSRSHAREJSONSCHEMA=		$(ROOTUSRSHAREJSON)/schema
ROOTUSRSHAREJSONVALIDATE=	$(ROOTUSRSHAREJSON)/soljsonvalidate
ROOTUSRSHAREJSONVALIDATESOL=	$(ROOTUSRSHAREJSON)/soljsonvalidate/solaris
ROOTUSRSHARESC=			$(ROOT)/usr/share/sysconfig
ROOTUSRSHAREDOC=		$(ROOT)/usr/share/doc
ROOTUSRSHARESCHELPC=		$(ROOTUSRSHARESC)/help/C
ROOTUSRSHARESCXSLT=		$(ROOTUSRSHARESC)/xslt
ROOTUSRSHARETIHELPC=		$(ROOT)/usr/share/text-install/help/C
ROOTUSRSHARESCFB=		$(ROOT)/usr/share/svc-create-first-boot
ROOTUSRSHARESCFBTEMP=		$(ROOTUSRSHARESCFB)/template
ROOTUSRSHARESCFBSITE=		$(ROOTUSRSHARESCFBTEMP)/lib/svc/method/site
ROOTUSRSHAREDOCSPLICE=		$(ROOTUSRSHAREDOC)/splice
ROOTUSRSHAREODOC=			$(ROOT)/usr/share/odoc

ROOTONBLDTEST=			$(ROOT)/opt/onbld/test
ROOTDEMODIRBASE=		$(ROOT)/usr/demo

#
# Like ROOTLIBDIR in $(SRC)/Makefile.lib, any lower-level Makefiles that
# put their binaries in a non-standard location should reset this and use
# $(ROOTCMD) in their `install' target. By default we set this to a bogus
# value so that it will not conflict with any of the other values already
# defined in this Makefile.
#
ROOTCMDDIR=	$(ROOT)/__nonexistent_directory__

ROOTSHAUDIO=	$(ROOT)/usr/share/audio
ROOTAUDIOSAMP=	$(ROOTSHAUDIO)/samples
ROOTAUDIOSAMPAU=$(ROOTAUDIOSAMP)/au

ISAEXEC=	$(ROOT)/usr/lib/isaexec
PLATEXEC=	$(ROOT)/usr/lib/platexec

LDLIBS =	$(LDLIBS.cmd)
LDFLAGS =	$(LDFLAGS.cmd)

LINTFLAGS=	-bxsm -m32
LINTFLAGS64=	-bxsm -m64
LINTOUT=	lint.out

KRB5LIBPROG=	$(PROG:%=$(KRB5LIB)/%)
ROOTPROG=	$(PROG:%=$(ROOTPROGDIR)/%)
ROOTCMD=	$(PROG:%=$(ROOTCMDDIR)/%)
ROOTSHFILES=	$(SHFILES:%=$(ROOTBIN)/%)
ROOTLIBPROG=	$(PROG:%=$(ROOTLIB)/%)
ROOTLIBSHFILES= $(SHFILES:%=$(ROOTLIB)/%)
ROOTSHLIBPROG=	$(PROG:%=$(ROOTSHLIB)/%)
ROOTPKGBINPROG= $(PROG:%=$(ROOTPKGBIN)/%)
ROOTCLASS_SCR_FILES= $(SCRIPTS:%=$(ROOTCLASS_SCR_DIR)/%)
ROOTUSRSBINPROG=$(PROG:%=$(ROOTUSRSBIN)/%)
ROOTUSRSBINSCRIPT=$(SCRIPT:%=$(ROOTUSRSBIN)/%)
ROOTETCPROG=	$(PROG:%=$(ROOTETC)/%)
ROOTSUNOSBINPROG= $(PROG:%=$(ROOTSUNOSBIN)/%)
ROOTSUNOSLIBPROG= $(PROG:%=$(ROOTSUNOSLIB)/%)
ROOTUSRKVMPROG=	$(PROG:%=$(ROOTUSRKVM)/%)
ROOTXPG4PROG=	$(XPG4PROG:%=$(ROOTXPG4BIN)/%)
ROOTXPG4PROG32=	$(XPG4PROG:%=$(ROOTXPG4BIN32)/%)
ROOTXPG4PROG64=	$(XPG4PROG:%=$(ROOTXPG4BIN64)/%)
ROOTXPG6PROG=	$(XPG6PROG:%=$(ROOTXPG6BIN)/%)
ROOTXPG7PROG=	$(XPG7PROG:%=$(ROOTXPG7BIN)/%)
ROOTLOCALEPROG=	$(PROG:%=$(ROOTLOCALEDEF)/%)
ROOTPROG64=	$(PROG:%=$(ROOTBIN64)/%)
ROOTPROG32=	$(PROG:%=$(ROOTBIN32)/%)
ROOTCMD64=	$(PROG:%=$(ROOTCMDDIR64)/%)
ROOTUSRSBINPROG32=	$(PROG:%=$(ROOTUSRSBIN32)/%)
ROOTUSRSBINPROG64=	$(PROG:%=$(ROOTUSRSBIN64)/%)

ROOTETCDEFAULT=	$(ROOTETC)/default
ROOTETCDEFAULTFILES=	$(DEFAULTFILES:%.dfl=$(ROOTETCDEFAULT)/%)
ROOTPRODUCT += $(ROOTETCDEFAULTFILES)

ROOTAUTHATTRDFILES=	$(AUTHATTRDFILES:auth_attr.%=$(ROOTAUTHATTRD)/%)
ROOTPRODUCT += $(ROOTAUTHATTRDFILES)

ROOTEXECATTRDFILES=	$(EXECATTRDFILES:exec_attr.%=$(ROOTEXECATTRD)/%)
ROOTPRODUCT += $(ROOTEXECATTRDFILES)

ROOTPROFATTRDFILES=	$(PROFATTRDFILES:prof_attr.%=$(ROOTPROFATTRD)/%)
ROOTPRODUCT += $(ROOTPROFATTRDFILES)

ROOTUSERATTRDFILES=	$(USERATTRDFILES:user_attr.%=$(ROOTUSERATTRD)/%)
ROOTPRODUCT += $(ROOTUSERATTRDFILES)

# Define the default text domain in this directory.
TEXT_DOMAIN= $(PROG:%=solaris_cmd_%)
POFILE= $(TEXT_DOMAIN:%=%.po)
C_MSGFILES= $(PROG:%=%.c)

# This flag is for programs which should not build a 32-bit binary
sparc_64ONLY= $(POUND_SIGN)
i386_64ONLY= $(POUND_SIGN)
64ONLY=	 $($(MACH)_64ONLY)

# This is for commands which need to include either of the values-xpg4.o or
# values-xpg6.o objects as part of compilation. Note that this is unnecessary
# for GCC-only builds, since GCC10 will already insert the CRT from the host
# build system.
VALUES_XPG4 = values-xpg4.o
VALUES_XPG6 = values-xpg6.o
$(__GNUC)VALUES_XPG4 =
$(__GNUC)VALUES_XPG6 =

# These are the preprocessor flags to add to XPG[467] compile and lint lines
XPG4FLAG = -DXPG4=1
XPG6FLAG = -DXPG6=1
XPG7FLAG = -DXPG7=1
