#
# Copyright (c) 2008, 2021, Oracle and/or its affiliates.
#

include $(SRC)/cmd/Makefile.cmd
include $(SRC)/cmd/Makefile.cmd.64

PROG = powertop
ROOTPROGDIR=	$(ROOTBIN)

COMMON_OBJS = $(PROG).o \
	display.o \
	battery.o \
	cpufreq.o \
	cpuidle.o \
	events.o \
	util.o \
	suggestions.o

EXTRA_OBJS = pt_$(MACH64).o
OBJS = $(COMMON_OBJS) $(EXTRA_OBJS)

SRCDIR 	=	../common
SRCS		= $(COMMON_OBJS:%.o=$(SRCDIR)/%.c)
SRCS		+= $(EXTRA_OBJS:%.o=%.c)

$(EXTRA_OBJS:%=$(BUILDDIR)/%) := SRCDIR = .

LDLIBS		+= -lcurses -ldtrace -lkstat2

CLEANFILES	+= $(COMMON_OBJS)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all:	$(BUILDPRODUCT)

install: $(ROOTPRODUCT)

lint:	lint64_SRCS

include $(SRC)/cmd/Makefile.targ
