/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Emulate required libgcrypt functions for use by the MPI library in GRUB.
 * This for Solaris Verified boot's use of libgcrypt functions in multiboot.
 */

/* gcrypt.h contains a subset of crypto.h definitions */

#ifndef _CRYPTO_H
#define	_CRYPTO_H

#include <gcrypt.h>

#ifdef	__cplusplus
extern "C" {
#endif

#ifdef	__cplusplus
}
#endif

#endif	/* _CRYPTO_H */
