/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Emulate required Solaris types for use by Solaris Verified Boot in GRUB.
 */

#ifndef _STDINT_H
#define	_STDINT_H

#ifdef	__cplusplus
extern "C" {
#endif

#ifndef _SIZE_T
#define	_SIZE_T
#if defined(__LP64__) || defined(_LP64)
typedef unsigned long	size_t;
#else
typedef unsigned int	size_t;
#endif
#endif

typedef unsigned int		int32_t;

typedef signed long		ssize_t;
typedef unsigned int		uint_t;
typedef unsigned char		uchar_t;
typedef unsigned short		ushort_t;
#ifdef _LP64
typedef unsigned long		uint64_t;
#else
typedef unsigned long long	uint64_t;
#endif
typedef unsigned int		uint32_t;
typedef unsigned short		uint16_t;
typedef unsigned char		uint8_t;

#ifdef	__cplusplus
}
#endif

#endif	/* _STDINT_H */
