/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * Emulate required libgcrypt functions for use by the MPI library in GRUB.
 * This for Solaris Verified boot's use of libgcrypt functions in multiboot.
 */


#ifndef _STRING_H
#define	_STRING_H

#include <sys/types.h>	/* size_t */

#ifdef	__cplusplus
extern "C" {
#endif

/* gcrypt_util.c */
size_t strlen(const char *s);

/* referenced in g10lib.h */
int strcasecmp(const char *s1, const char *s2);

char *strchr(const char *s, int c);

#ifdef	__cplusplus
}
#endif

#endif	/* _STRING_H */
