/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * This is a "placeholder" header file to take the place of the usual
 * header file containing the ephmeral development public key for
 * on_closed_bins builds, where the usr/closed source tree is not present.
 * The usual verify_key2.h directory, keep/$(isainfo -k)/signing-material,
 * should be specified with CPPFLAGS -I ahead of this directory.
 */

#ifndef _SYS_VERIFY_KEY2_H
#define	_SYS_VERIFY_KEY2_H

#include <sys/verified_boot.h>

static const uchar_t internal_dn_hash[VERIFY_DN_HASH_LEN];
static const uchar_t internal_modulus[VERIFY_MODULUS_LEN];

#endif	/* _SYS_VERIFY_KEY2_H */
