/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2012, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef GRUB_SMBIOS_HEADER
#define GRUB_SMBIOS_HEADER 1

#include <grub/types.h>

struct grub_smbios_entry_point {
	grub_uint8_t	ep_anchor[4];
	grub_uint8_t	ep_cksum;
	grub_uint8_t	ep_length;
	grub_uint8_t	ep_major;
	grub_uint8_t	ep_minor;
	grub_uint16_t	ep_maxsize;
	grub_uint8_t	ep_rev;
	grub_uint8_t	ep_formatted[5];
	grub_uint8_t	ep_ianchor[5];
	grub_uint8_t	ep_icksum;
	grub_uint16_t	ep_table_length;
	grub_uint32_t	ep_table_addr;
	grub_uint16_t	ep_struct_count;
	grub_uint8_t	ep_bcdrev;
} __attribute__ ((packed));

#endif
