/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2016, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GRUB_NET_HTTPS_TIME_HEADER
#define GRUB_NET_HTTPS_TIME_HEADER

#include <grub/time.h>

#ifndef _TIME_T
#define _TIME_T
typedef long time_t;
#endif /* _TIME_T */

typedef struct timeval
{
  time_t tv_sec;
  long tv_usec;
} timeval_t;

typedef struct timespec
{
  time_t tv_sec;
  long tv_nsec;
} timespec_t;

struct tm
{
  int tm_sec;
  int tm_min;
  int tm_hour;
  int tm_mday;
  int tm_mon;
  int tm_year;
  int tm_wday;
  int tm_yday;
  int tm_isdst;
};

#endif	/* GRUB_NET_HTTPS_TIME_HEADER */
