/*
 *  GRUB  --  GRand Unified Bootloader
 *  Copyright (c) 2010, 2012, Oracle and/or its affiliates. All rights reserved.
 *
 *  GRUB is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  GRUB is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GRUB.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef GRUB_UTIL_VERSION_HEADER
#define GRUB_UTIL_VERSION_HEADER	1

/*
 * grub_util_version_info describes associates a versioning scheme to
 * its comparing function. compare() is expected to return 0 if the two
 * passed versions coincide, more than 0 if the first version is more recent
 * than the second and less than 0 otherwise. (basically, compare behaves
 * like strcmp()).
 */
struct grub_util_version_info
{
  char *versioning_scheme;
  int (*compare)(const char *, const char *);
  const char *static_version;
  int compulsory; /* If both source and dest MUST be present */
};

/* "solaris_version" handler. */
extern struct grub_util_version_info grub_util_solaris_grub_version;

#endif /* ! GRUB_UTIL_VERSION_HEADER */
