#
# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
#

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64
include $(SRC)/cmd/hal/Makefile.hal

CPPFLAGS =	$(HAL_DBUS_CPPFLAGS) $(HAL_GLIB_CPPFLAGS) $(CPPFLAGS.master)

LIBDIR =	/usr/lib
LIBDIR64 =	/usr/lib/$(MACH64)
ROOTLIBPCDIR =	$(ROOT)/usr/lib/pkgconfig
ROOTLIBPCDIR64 = $(ROOT)/usr/lib/$(MACH64)/pkgconfig
ROOTLIBPC =	$(LIBPCSRC:%=$(ROOTLIBPCDIR)/%)
ROOTLIBPC64 =	$(LIBPCSRC:%=$(ROOTLIBPCDIR64)/%)

$(ROOTLIBPC) := FILEMODE= 0644
$(ROOTLIBPC64) := FILEMODE= 0644

CLOBBERFILES +=	$(LIBPCSRC)

LINTCHECKFLAGS +=       -erroff=E_FUNC_RET_ALWAYS_IGNOR2 -erroff=E_FUNC_ARG_UNUSED \
			-erroff=E_CONSTANT_CONDITION

#
# Ensure `all' is the default target.
#
all:

# no lint for 3rd party code
lint:

$(ROOTLIBPC): $(ROOTLIBPCDIR) $(BUILDDIR)/$(LIBPCSRC)
	$(INS.file) $(BUILDDIR)/$(LIBPCSRC)

$(ROOTLIBPC64): $(ROOTLIBPCDIR64) $(BUILDDIR)/$(LIBPCSRC)
	$(INS.file) $(BUILDDIR)/$(LIBPCSRC)

$(BUILDDIR)/$(LIBPCSRC): ../common/$(LIBPCSRC).in
	$(SED)	-e "s@__VERSION__@$(HAL_VERSION)@" \
		-e "s@__LIBDIR__@$(LIBDIR)@" \
		 < ../common/$(LIBPCSRC).in > $@

