#
# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
#
#
# usr/src/lib/hal/libhal/Makefile.com
#

LIBRARY =	libhal.a
VERS =		.1.0.0
VERS_MAJ =	.1
OBJECTS =	libhal.o
LIBPCSRC =	hal.pc

include ../../Makefile.com

LIBS =		$(DYNLIB) $(LINTLIB)
LDLIBS +=	-lc
$(BUILDLIBS) := LDLIBS += -ldbus-1
LINTLIB_SRCS = $(SRCDIR)/$(LINTSRC)

SRCDIR =	../common

CFLAGS +=	$(CCVERBOSE)
CPPFLAGS +=	$(HAL_CONFIG_CPPFLAGS)
CPPFLAGS +=	-DGETTEXT_PACKAGE=\"$(HAL_GETTEXT_PACKAGE)\" -DENABLE_NLS

ROOTMAJLINK =	$(ROOTLIBDIR)/$(LIBRARY:.a=.so)$(VERS_MAJ)
ROOTMAJLINK64 =	$(ROOTLIBDIR64)/$(LIBRARY:.a=.so)$(VERS_MAJ)
STUBROOTMAJLINK =	$(STUBROOTLIBDIR)/$(LIBRARY:.a=.so)$(VERS_MAJ)
STUBROOTMAJLINK64 =	$(STUBROOTLIBDIR64)/$(LIBRARY:.a=.so)$(VERS_MAJ)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

$(ROOTMAJLINK) $(STUBROOTMAJLINK):
	-$(RM) $@; $(SYMLINK) $(DYNLIB) $@

$(ROOTMAJLINK64) $(STUBROOTMAJLINK64):
	-$(RM) $@; $(SYMLINK) $(DYNLIB) $@

include $(SRC)/lib/Makefile.targ
