#
# Copyright (c) 2008, 2021, Oracle and/or its affiliates.
#

LIBRARY =	libHBAAPI.a
VERS =		.1
OBJECTS	=	HBAAPILIB-sun.o	HBAAPILIB.o
CONFIGFILE=	hba.conf
ROOTETC=	$(ROOT)/etc

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

HETCFILES=	$(CONFIGFILE:%=$(ROOTETC)/%)
$(HETCFILES) :=	FILEMODE= 0644

LIBS =		$(DYNLIB)
LIBS_P =	$(LINTLIB)
SRCDIR=		../common

INCS +=		-I$(SRCDIR)
CPPFLAGS +=	$(INCS)

LDLIBS +=	-lc

LINTLIB_SRCS=	$(SRCDIR)/$(LINTSRC)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all:	stub $(BUILDLIBS) $(BUILDLIBS_P) $(HETCFILES)

$(CONS32)install: stubinstall all $(ROOTLIBS) $(ROOTLINKS)
$(CONS64)install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

$(ROOTETC)/%:	../common/%
	$(INS.file)

include $(SRC)/lib/Makefile.targ
