#
# Copyright (c) 2011, 2021, Oracle and/or its affiliates.
#

LIBRARY =	libfuse.a
VERS =		.1

FUSE_VERSION =	2.7.4

FUSE_OBJS = \
	options.o \
	fuse_uvfs.o \
	util.o
COM_OBJS = list.o
OBJECTS = $(FUSE_OBJS) $(COM_OBJS)
LIBPCSRC = fuse.pc

LIBDIR=         /usr/lib
ROOTLIBPCDIR64 =  $(ROOT)/usr/lib/$(MACH64)/pkgconfig
ROOTLIBPC64 =   $(LIBPCSRC:%=$(ROOTLIBPCDIR64)/%)


$(ROOTLIBPCDIR64)/% := FILEMODE= 0644

include $(SRC)/lib/Makefile.lib
include $(SRC)/lib/Makefile.lib.64

SRCDIR =	../common
COMDIR =	$(SRC_REL)/common/list

C_MSGFILES =	$(SRCDIR)/fuse_uvfs.c $(SRCDIR)/util.c
MSGTARGET =	msg_msg

LIBS =		$(DYNLIB) $(LINTLIB)
LDLIBS +=	-lavl -lumem -luvfs -lc

SRCS = \
	$(FUSE_OBJS:%.o=$(SRCDIR)/%.c) \
	$(COM_OBJS:%.o=$(COMDIR)/%.c)
LINTLIB_SRCS = $(SRCDIR)/$(LINTSRC)

INCS	 	+= -I$(SRCDIR)
CPPFLAGS	+= $(INCS)
CPPFLAGS 	+= -D__SOLARIS__ -DFUSE_USE_VERSION=26

CLOBBERFILES += $(BUILDDIR)/$(LIBPCSRC)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS) $(BUILDDIR)/$(LIBPCSRC)

install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64) $(ROOTLINT) \
	$(ROOTLIBPC64)

stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

lint: strictlintcheck64

$(BUILDDIR)/pics/%.o: $(COMDIR)/%.c
	$(COMPILE.c) -o $@ $<
	$(POST_PROCESS_O)

$(ROOTLIBPCDIR64)/%: $(BUILDDIR)/%
	$(INS.file)

$(BUILDDIR)/$(LIBPCSRC): ../common/$(LIBPCSRC).in
	$(SED)  -e "s@__VERSION__@$(FUSE_VERSION)@" \
		-e "s@__LIBDIR__@$(LIBDIR)@" \
		< ../common/$(LIBPCSRC).in > $@

include $(SRC)/lib/Makefile.targ
