#
# Copyright (c) 2008, 2021, Oracle and/or its affiliates.
#

LIBRARY=	libima.a
VERS=		.1
OBJECTS=	ima-lib.o sunima-lib.o
ROOTETC=	$(ROOT)/etc

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

FILES1 =	ima.conf	
ROOTFILES1DIR =	$(ROOTETC)
ROOTFILES1 =	$(FILES1:%=$(ROOTFILES1DIR)/%)	
$(ROOTFILES1) :=		FILEMODE = 0644

LIBS =		$(DYNLIB) $(LINTLIB)
LDLIBS +=	-lc

HDRS=		ima.h libsun_ima.h
HDRDIR=		../common
NOCHECKHDRS=	ima.h
INCS +=		../common

CFLAGS +=	-xCC
CFLAGS64 +=	-xCC

CPPFLAGS +=	-DSOLARIS
CPPFLAGS +=	-I$(INCS)

CSTDMODE =	$(C89_MODE)

SRCDIR =	../common
LINTLIB_SRCS=	$(SRCDIR)/$(LINTSRC)

.KEEP_STATE_FILE:   $(BUILDDIR)/.make.state.$(MACH)

all:	stub $(BUILDLIBS) $(ROOTFILES1)

$(CONS32)install: stubinstall all $(ROOTLIBS) $(ROOTLINKS) $(ROOTLINT)
$(CONS64)install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

include $(SRC)/lib/Makefile.targ
