/*
 * Copyright (c) 2009, 2015, Oracle and/or its affiliates. All rights reserved.
 */

/* header file for iSCSI tunable parameters properties function */

#ifndef	_LIBSUN_IMA_H
#define	_LIBSUN_IMA_H

#define	ISCSI_TUNABLE_MAX	3600
#define	ISCSI_TUNABLE_MIN	0
#ifdef __cplusplus
extern "C" {
#endif

#include <ima.h>

typedef enum {
	ISCSI_RX_TIMEOUT_VALUE = 1,
	ISCSI_CONN_DEFAULT_LOGIN_MAX = 2,
	ISCSI_LOGIN_POLLING_DELAY = 3
} ISCSI_TUNABLE_OBJECT_TYPE;

typedef struct _ISCSI_TUNABLE_PARAM {
	ISCSI_TUNABLE_OBJECT_TYPE tunable_objectType;
	IMA_CHAR *tunable_objectValue;
} ISCSI_TUNABLE_PARAM;

/*
 * Custom struct to allow tgpt to be specified.
 */
typedef struct _SUN_IMA_DISCOVERY_ADDRESS_KEY
{
	IMA_NODE_NAME name;
	IMA_ADDRESS_KEY address;
	IMA_UINT16 tpgt;
} SUN_IMA_DISCOVERY_ADDRESS_KEY;

typedef struct _SUN_IMA_DISCOVERY_ADDRESS_KEY_PROPERTIES
{
	IMA_UINT keyCount;
	SUN_IMA_DISCOVERY_ADDRESS_KEY keys[1];
} SUN_IMA_DISCOVERY_ADDRESS_KEY_PROPERTIES;

IMA_API IMA_STATUS SUN_IMA_SetTunableProperties(
		IMA_OID oid,
		ISCSI_TUNABLE_PARAM *param
);

IMA_API IMA_STATUS SUN_IMA_GetTunableProperties(
		IMA_OID oid,
		ISCSI_TUNABLE_PARAM *param
);


IMA_API IMA_STATUS SUN_IMA_GetSendTargetsList(
		IMA_OID oid,
		IMA_TARGET_ADDRESS address,
		SUN_IMA_DISCOVERY_ADDRESS_KEY_PROPERTIES **ppList
);

#ifdef __cplusplus
}
#endif

#endif /* _LIBSUN_IMA_H */
