#!/usr/bin/python

#
# Copyright (c) 2012, 2020, Oracle and/or its affiliates. All rights reserved.
#

""" constants and enums from ima.h
"""

IMA_OBJECT_TYPE = (
    IMA_OBJECT_TYPE_UNKNOWN,
    IMA_OBJECT_TYPE_PLUGIN,
    IMA_OBJECT_TYPE_NODE,
    IMA_OBJECT_TYPE_LHBA,
    IMA_OBJECT_TYPE_PHBA,
    IMA_OBJECT_TYPE_NETWORK_PORTAL,
    IMA_OBJECT_TYPE_PORTAL_GROUP,
    IMA_OBJECT_TYPE_LNP,
    IMA_OBJECT_TYPE_PNP,
    IMA_OBJECT_TYPE_TARGET,
    IMA_OBJECT_TYPE_LU,
    IMA_OBJECT_TYPE_DISCOVERY_ADDRESS,
    IMA_OBJECT_TYPE_STATIC_DISCOVERY_TARGET,
    IMA_OBJECT_TYPE_CONNECTION,
    IMA_OBJECT_TYPE_SESSION
) = range(15)

IMA_OBJECT_TYPE_MAP = {
    IMA_OBJECT_TYPE_UNKNOWN: "IMA_OBJECT_TYPE_UNKNOWN",
    IMA_OBJECT_TYPE_PLUGIN: "IMA_OBJECT_TYPE_PLUGIN",
    IMA_OBJECT_TYPE_NODE: "IMA_OBJECT_TYPE_NODE",
    IMA_OBJECT_TYPE_LHBA: "IMA_OBJECT_TYPE_LHBA",
    IMA_OBJECT_TYPE_PHBA: "IMA_OBJECT_TYPE_PHBA",
    IMA_OBJECT_TYPE_NETWORK_PORTAL: "IMA_OBJECT_TYPE_NETWORK_PORTAL",
    IMA_OBJECT_TYPE_PORTAL_GROUP: "IMA_OBJECT_TYPE_PORTAL_GROUP",
    IMA_OBJECT_TYPE_LNP: "IMA_OBJECT_TYPE_LNP",
    IMA_OBJECT_TYPE_PNP: "IMA_OBJECT_TYPE_PNP",
    IMA_OBJECT_TYPE_TARGET: "IMA_OBJECT_TYPE_TARGET",
    IMA_OBJECT_TYPE_LU: "IMA_OBJECT_TYPE_LU",
    IMA_OBJECT_TYPE_DISCOVERY_ADDRESS: "IMA_OBJECT_TYPE_DISCOVERY_ADDRESS",
    IMA_OBJECT_TYPE_STATIC_DISCOVERY_TARGET:
        "IMA_OBJECT_TYPE_STATIC_DISCOVERY_TARGET",
    IMA_OBJECT_TYPE_CONNECTION: "IMA_OBJECT_TYPE_CONNECTION",
    IMA_OBJECT_TYPE_SESSION: "IMA_OBJECT_TYPE_SESSION",
    "IMA_OBJECT_TYPE_UNKNOWN": IMA_OBJECT_TYPE_UNKNOWN,
    "IMA_OBJECT_TYPE_PLUGIN": IMA_OBJECT_TYPE_PLUGIN,
    "IMA_OBJECT_TYPE_NODE": IMA_OBJECT_TYPE_NODE,
    "IMA_OBJECT_TYPE_LHBA": IMA_OBJECT_TYPE_LHBA,
    "IMA_OBJECT_TYPE_PHBA": IMA_OBJECT_TYPE_PHBA,
    "IMA_OBJECT_TYPE_NETWORK_PORTAL": IMA_OBJECT_TYPE_NETWORK_PORTAL,
    "IMA_OBJECT_TYPE_PORTAL_GROUP": IMA_OBJECT_TYPE_PORTAL_GROUP,
    "IMA_OBJECT_TYPE_LNP": IMA_OBJECT_TYPE_LNP,
    "IMA_OBJECT_TYPE_PNP": IMA_OBJECT_TYPE_PNP,
    "IMA_OBJECT_TYPE_TARGET": IMA_OBJECT_TYPE_TARGET,
    "IMA_OBJECT_TYPE_LU": IMA_OBJECT_TYPE_LU,
    "IMA_OBJECT_TYPE_DISCOVERY_ADDRESS": IMA_OBJECT_TYPE_DISCOVERY_ADDRESS,
    "IMA_OBJECT_TYPE_STATIC_DISCOVERY_TARGET":
        IMA_OBJECT_TYPE_STATIC_DISCOVERY_TARGET,
    "IMA_OBJECT_TYPE_CONNECTION": IMA_OBJECT_TYPE_CONNECTION,
    "IMA_OBJECT_TYPE_SESSION": IMA_OBJECT_TYPE_SESSION
}

IMA_AUTHMETHOD = (
    IMA_AUTHMETHOD_NONE,
    IMA_AUTHMETHOD_CHAP,
    IMA_AUTHMETHOD_SRP,
    IMA_AUTHMETHOD_KRB5,
    IMA_AUTHMETHOD_SPKM1,
    IMA_AUTHMETHOD_SPKM2
) = range(6)

IMA_AUTHMETHOD_MAP = {
    IMA_AUTHMETHOD_NONE: "IMA_AUTHMETHOD_NONE",
    IMA_AUTHMETHOD_CHAP: "IMA_AUTHMETHOD_CHAP",
    IMA_AUTHMETHOD_SRP: "IMA_AUTHMETHOD_SRP",
    IMA_AUTHMETHOD_KRB5: "IMA_AUTHMETHOD_KRB5",
    IMA_AUTHMETHOD_SPKM1: "IMA_AUTHMETHOD_SPKM1",
    IMA_AUTHMETHOD_SPKM2: "IMA_AUTHMETHOD_SPKM2",
    "IMA_AUTHMETHOD_NONE": IMA_AUTHMETHOD_NONE,
    "IMA_AUTHMETHOD_CHAP": IMA_AUTHMETHOD_CHAP,
    "IMA_AUTHMETHOD_SRP": IMA_AUTHMETHOD_SRP,
    "IMA_AUTHMETHOD_KRB5": IMA_AUTHMETHOD_KRB5,
    "IMA_AUTHMETHOD_SPKM1": IMA_AUTHMETHOD_SPKM1,
    "IMA_AUTHMETHOD_SPKM2": IMA_AUTHMETHOD_SPKM2
}

ISCSI_MAX_NAME_LEN = 224
ISCSI_MAX_C_USER_LEN = 512
ISCSI_IOCTL = ((ord('i') << 24) | (ord('S') << 16) | (ord('C') << 8))
ISCSI_BOOTPROP_GET = ISCSI_IOCTL | 48
