#
# Copyright (c) 2009, 2017, Oracle and/or its affiliates. All rights reserved.
#

LIBRARY=	libparted.a
VERS=		.8

PARTED_VERSION=	2.3.0

#
# All relative to SRCDIR
#

PLIBDIR=	lib
LIBPDIR=	libparted
LIBPADIR=	libparted/arch
LIBPCSDIR=	libparted/cs
LIBAMIGAFS=	libparted/fs/amiga
LIBEXT2FS=	libparted/fs/ext2
LIBFATFS=	libparted/fs/fat
LIBHFS=		libparted/fs/hfs
LIBJFS=		libparted/fs/jfs
LIBLINUXSWAP=	libparted/fs/linux_swap
LIBNTFS=	libparted/fs/ntfs
LIBREISERFS=	libparted/fs/reiserfs
LIBSOLARISX86=	libparted/fs/solaris_x86
LIBUFS=		libparted/fs/ufs
LIBXFS=		libparted/fs/xfs
LIBLABELS=	libparted/labels


OBJECTS=	$(PLIBDIR)/argmatch.o \
		$(PLIBDIR)/quotearg.o \
		$(PLIBDIR)/close-stream.o	$(PLIBDIR)/closeout.o \
		$(PLIBDIR)/error.o \
		$(PLIBDIR)/exitfail.o \
		$(PLIBDIR)/version-etc-fsf.o \
		$(PLIBDIR)/version-etc.o \
		$(PLIBDIR)/xalloc-die.o		$(PLIBDIR)/xmalloc.o \
		$(PLIBDIR)/progname.o \
		$(PLIBDIR)/quote.o		$(LIBPDIR)/architecture.o \
		$(LIBPDIR)/debug.o		$(LIBPDIR)/exception.o \
		$(LIBPDIR)/device.o		$(LIBPDIR)/filesys.o \
		$(LIBPDIR)/timer.o		$(LIBPDIR)/unit.o \
		$(LIBPDIR)/disk.o		$(LIBPDIR)/libparted.o \
		$(LIBPADIR)/solaris.o \
		$(LIBPCSDIR)/constraint.o	$(LIBPCSDIR)/geom.o \
		$(LIBPCSDIR)/natmath.o \
		$(LIBAMIGAFS)/affs.o		$(LIBAMIGAFS)/amiga.o  \
		$(LIBAMIGAFS)/apfs.o		$(LIBAMIGAFS)/asfs.o  \
		$(LIBAMIGAFS)/interface.o \
		$(LIBEXT2FS)/interface.o	$(LIBEXT2FS)/ext2.o \
		$(LIBEXT2FS)/ext2_inode_relocator.o \
		$(LIBEXT2FS)/parted_io.o	$(LIBEXT2FS)/ext2_meta.o \
		$(LIBEXT2FS)/ext2_block_relocator.o \
		$(LIBEXT2FS)/ext2_mkfs.o	$(LIBEXT2FS)/tune.o \
		$(LIBEXT2FS)/ext2_buffer.o	$(LIBEXT2FS)/ext2_resize.o \
		$(LIBFATFS)/table.o		$(LIBFATFS)/bootsector.o \
		$(LIBFATFS)/clstdup.o		$(LIBFATFS)/count.o \
		$(LIBFATFS)/fatio.o		$(LIBFATFS)/traverse.o \
		$(LIBFATFS)/calc.o		$(LIBFATFS)/context.o \
		$(LIBFATFS)/fat.o		$(LIBFATFS)/resize.o \
		$(LIBHFS)/cache.o		$(LIBHFS)/probe.o \
		$(LIBHFS)/advfs.o		$(LIBHFS)/hfs.o \
		$(LIBHFS)/file.o		$(LIBHFS)/reloc.o \
		$(LIBHFS)/advfs_plus.o		$(LIBHFS)/journal.o \
		$(LIBHFS)/file_plus.o		$(LIBHFS)/reloc_plus.o \
		$(LIBJFS)/jfs.o \
		$(LIBLINUXSWAP)/linux_swap.o \
		$(LIBNTFS)/ntfs.o \
		$(LIBREISERFS)/reiserfs.o \
		$(LIBSOLARISX86)/solaris_x86.o \
		$(LIBUFS)/ufs.o \
		$(LIBXFS)/xfs.o \
		$(LIBLABELS)/dos.o		$(LIBLABELS)/efi_crc32.o \
		$(LIBLABELS)/mac.o		$(LIBLABELS)/sun.o \
		$(LIBLABELS)/aix.o		$(LIBLABELS)/dvh.o \
		$(LIBLABELS)/gpt.o		$(LIBLABELS)/pc98.o \
		$(LIBLABELS)/bsd.o		$(LIBLABELS)/loop.o \
		$(LIBLABELS)/pt-tools.o		$(LIBLABELS)/rdb.o

# include library definitions
include		../../Makefile.lib
$(CONS64)include ../../Makefile.lib.64

SRCDIR =	../common

TEXT_DOMAIN=		solaris_lib_parted
SRCS=			$(OBJECTS:%.o=$(SRCDIR)/%.c)
C_MSGFILES=		$(SRCS)
CPPFLAGS +=		-DENABLE_NLS
$(CONS64)MSGTARGET=	msg_msg

# change the location message files are installed
MSGDOMAINPOFILE = $(POFILE:%=$(ROOTSHAREMSGDIR)/%)

# The following objects are unused.  Refer to comments in Makefile.master.
UNUSEDOBJS =	$(PLIBDIR)/basename.o		$(PLIBDIR)/basename-lgpl.o \
		$(PLIBDIR)/dirname.o		$(PLIBDIR)/safe-read.o \
		$(PLIBDIR)/dirname-lgpl.o	$(PLIBDIR)/stripslash.o \
		$(PLIBDIR)/strndup.o		$(PLIBDIR)/localcharset.o \
		$(PLIBDIR)/xstrndup.o		$(LIBREISERFS)/geom_dal.o
UNUSEDFILES =	$(UNUSEDOBJS:%.o=$(SRCDIR)/%.c) \
		$(SRCDIR)/lib/dirname.h		$(SRCDIR)/lib/localcharset.h \
		$(SRCDIR)/lib/safe-read.h	$(SRCDIR)/lib/xstrndup.h
POST_PROCESS_SO += $(ACCESS_UNUSEDFILES)

CERRWARN +=	-erroff=E_EXTERN_INLINE_UNDEFINED
CERRWARN +=	-erroff=E_CONST_PROMOTED_UNSIGNED_LONG

LIBS =		$(DYNLIB)

CFLAGS +=	$(CCVERBOSE)
CPPFLAGS +=	-I$(SRCDIR)/lib -I$(SRCDIR)/include -I$(SRCDIR)/libparted
DYNFLAGS +=	$(ZINTERPOSE)
LDLIBS +=	-ldiskmgt -luuid -lc -lnvpair

LIBDIR=		/usr/lib
LIBDIR64=	/usr/lib/$(MACH64)
LIBPCSRC =	libparted.pc
ROOTLIBPCDIR =  $(ROOT)/usr/lib/pkgconfig
ROOTLIBPCDIR64= $(ROOT)/usr/lib/$(MACH64)/pkgconfig
ROOTLIBPC =	$(LIBPCSRC:%=$(ROOTLIBPCDIR)/%)
ROOTLIBPC64 =   $(LIBPCSRC:%=$(ROOTLIBPCDIR64)/%)

$(ROOTLIBPC) := FILEMODE= 0644
$(ROOTLIBPC64) := FILEMODE= 0644

CLOBBERFILES += $(LIBPCSRC)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

ALLDIRS_1 =	$(PLIBDIR) \
		$(LIBPDIR) \
		$(LIBPADIR) \
		$(LIBPCSDIR) \
		$(LIBAMIGAFS) \
		$(LIBEXT2FS) \
		$(LIBFATFS) \
		$(LIBHFS) \
		$(LIBJFS) \
		$(LIBLINUXSWAP) \
		$(LIBNTFS) \
		$(LIBREISERFS) \
		$(LIBSOLARISX86) \
		$(LIBUFS) \
		$(LIBXFS) \
		$(LIBLABELS)
ALLDIRS = $(ALLDIRS_1:%=$(BUILDDIR)/pics/%)

#
# This open source is exempted from lint
#
lint:	lint_exempt

all: $(ALLDIRS) .WAIT $(BUILDLIBS)

$(CONS32)install: $(ALLDIRS) .WAIT \
	$(ROOTLIBS) $(ROOTLINKS) $(DYNLINKLIB) $(ROOTLIBPC)

$(CONS32)stubinstall: $(STUBROOTLIBS) $(STUBROOTLINKS)

$(CONS64)install: $(ALLDIRS) .WAIT $(ROOTLIBS64) $(ROOTLINKS64) $(ROOTLIBPC64)

$(CONS64)stubinstall: $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(ALLDIRS):
	?$(MKDIR) -p $(@)

$(ROOTLIBPCDIR):
	$(INS.dir)

$(ROOTLIBPCDIR)/% $(ROOTLIBPCDIR64)/%: $(BUILDDIR)/%
	$(INS.file)

$(BUILDDIR)/$(LIBPCSRC): ../common/$(LIBPCSRC).in
	$(SED)	-e "s@__VERSION__@$(PARTED_VERSION)@" \
                -e "s@__LIBDIR__@$(LIBDIR)@" \
		 < ../common/$(LIBPCSRC).in > $@

# include library targets
include		../../Makefile.targ
