#
# Copyright (c) 2009, 2021, Oracle and/or its affiliates.
#

LIBRARY =	librstp.a
VERS =		.1
OBJECTS =	edge.o migrate.o p2p.o pcost.o port.o portinfo.o rolesel.o \
		roletrns.o statmch.o stp_in.o stpm.o stpmgmt.o sttrans.o \
		times.o topoch.o transmit.o vector.o

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

LIBS =		$(DYNLIB)
LIBS_P =	$(LINTLIB)

SRCDIR =	../common
SRCS =		$(OBJECTS:%.o=$(SRCDIR)/%.c)

LINTLIB_SRCS =	$(SRCDIR)/$(LINTSRC)

LDLIBS +=	-lc

CPPFLAGS +=	-I$(SRCDIR) -D__SUN__ -D__STP_INTERNAL__

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS) $(BUILDLIBS_P)

$(CONS32)install: stubinstall all $(ROOTLIBS)
$(CONS64)install: stubinstall all $(ROOTLIBS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

include $(SRC)/lib/Makefile.targ
