#
# Copyright (c) 2008, 2021, Oracle and/or its affiliates.
#

LIBRARY=	libMPAPI.a
VERS=		.1
OBJECTS=	mpapi.o mpapi-sun.o

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

INSTALL_LIBDIR=	lib

SRCDIR = 	../common

LIBS =		$(DYNLIB) $(LINTLIB)
LDLIBS +=	-lc

LINTLIB_SRCS =	$(SRCDIR)/$(LINTSRC)

CPPFLAGS +=	-I$(SRCDIR)
CPPFLAGS +=	-DBUILD_TIME='"Wed Sep 24 12:00:00 2008"'
DYNFLAGS +=	-z finiarray=ExitLibrary
DYNFLAGS +=	-z initarray=InitLibrary

ROOTETC =	$(ROOT)/etc
CONFDIR =	../common
CONFFILE =	$(CONFDIR)/mpapi.conf
IETCFILES =     $(CONFFILE:$(CONFDIR)/%=$(ROOTETC)/%)
$(IETCFILES) := FILEMODE = 0644

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS) $(IETCFILES)

$(CONS32)install: stubinstall all $(ROOTLIBS) $(ROOTLINKS) $(ROOTLINT)
$(CONS64)install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

$(ROOTETC)/%:	$(CONFDIR)/%
	$(INS.file)

include $(SRC)/lib/Makefile.targ
