#
# Copyright (c) 2009, 2021, Oracle and/or its affiliates.
#

LIBRARY =	pkcs11_tpm.a
VERS =		.1

OBJECTS= api_interface.o \
	apiutil.o \
	asn1.o \
	cert.o \
	data_obj.o \
	decr_mgr.o \
	dig_mgr.o \
	encr_mgr.o \
	globals.o \
	hwf_obj.o \
	key.o \
	key_mgr.o \
	loadsave.o \
	log.o \
	mech_md5.o \
	mech_rsa.o \
	mech_sha.o \
	new_host.o \
	obj_mgr.o \
	object.o \
	sess_mgr.o \
	sign_mgr.o \
	template.o \
	tpm_specific.o \
	utility.o \
	verify_mgr.o


include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

SRCDIR= ../common

SRCS=	$(OBJECTS:%.o=$(SRCDIR)/%.c)

INSTALL_LIBDIR=	usr/lib/security

LIBS=$(DYNLIB) $(DYNLIB64)

LDLIBS += $(EXTRALIBS) -lc -luuid -lucrypto -ltspi -lcrypto
CPPFLAGS += $(TSSINC)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS)

#$(CONS32)lint: lintcheck
#$(CONS64)lint: strictlintcheck64
lint: lint_unclean

$(CONS32)install: stubinstall all $(ROOTLIBS) $(ROOTLINKS)
$(CONS64)install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

include $(SRC)/lib/Makefile.targ
