#
# Copyright (c) 2006, 2015, Oracle and/or its affiliates. All rights reserved.
#
# usr/src/lib/policykit/libpolkit/Makefile.com
#

LIBRARY =	libpolkit.a
VERS =		.0.0.0
VERS_MAJ =	.0
OBJECTS =	libpolkit-rbac.o
LIBPCSRC =	polkit.pc

include ../../Makefile.com
$(CONS64)include $(SRC)/lib/Makefile.lib.64

LIBS =		$(DYNLIB) $(LINTLIB)
LDLIBS +=	-lc
$(BUILDLIBS) := LDLIBS += $(POLICYKIT_GLIB_LDLIBS)
LINTLIB_SRCS =	$(SRCDIR)/$(LINTSRC)
LINTCHECKFLAGS  +=	-erroff=E_FUNC_RET_ALWAYS_IGNOR2 -erroff=E_NAME_USED_NOT_DEF2

SRCDIR =	../common

CFLAGS +=	$(CCVERBOSE)
CPPFLAGS +=	-DPACKAGE_LOCALE_DIR=\"/usr/lib/locale\"

ROOTMAJLINK =	$(ROOTLIBDIR)/$(LIBRARY:.a=.so)$(VERS_MAJ)
ROOTMAJLINK64 = $(ROOTLIBDIR64)/$(LIBRARY:.a=.so)$(VERS_MAJ)
STUBROOTMAJLINK=$(STUBROOTLIBDIR)/$(LIBRARY:.a=.so)$(VERS_MAJ)
STUBROOTMAJLINK64=$(STUBROOTLIBDIR64)/$(LIBRARY:.a=.so)$(VERS_MAJ)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all: stub $(BUILDLIBS)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

$(ROOTMAJLINK) $(STUBROOTMAJLINK):
	-$(RM) $@; $(SYMLINK) $(DYNLIB) $@

$(ROOTMAJLINK64) $(STUBROOTMAJLINK64):
	-$(RM) $@; $(SYMLINK) $(DYNLIB) $@
include $(SRC)/lib/Makefile.targ
