#
# Copyright (c) 2009, 2021, Oracle and/or its affiliates.
#

LIBRARY =	libSMHBAAPI.a
VERS =		.1
OBJECTS	=	SMHBAAPILIB.o
CONFIGFILE=	smhba.conf
ROOTETC=	$(ROOT)/etc

include $(SRC)/lib/Makefile.lib
$(CONS64)include $(SRC)/lib/Makefile.lib.64

HETCFILES=	$(CONFIGFILE:%=$(ROOTETC)/%)
$(HETCFILES) := FILEMODE= 0644

LIBS =		$(DYNLIB) $(LINTLIB)
SRCDIR=		../common

CPPFLAGS +=	-DSOLARIS
CPPFLAGS +=	-DVERSION='"Version 1"'
CPPFLAGS +=	-DUSESYSLOG
CPPFLAGS +=	$(INCS)
CPPFLAGS +=	-DPOSIX_THREADS

LDLIBS +=	-lc

LINTLIB_SRCS=	$(SRCDIR)/$(LINTSRC)

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

all:	stub $(BUILDLIBS) $(HETCFILES)

$(CONS32)install: stubinstall all $(ROOTLIBS) $(ROOTLINKS) $(ROOTLINT)
$(CONS64)install: stubinstall all $(ROOTLIBS64) $(ROOTLINKS64)

$(CONS32)stubinstall: stub $(STUBROOTLIBS) $(STUBROOTLINKS)
$(CONS64)stubinstall: stub $(STUBROOTLIBS64) $(STUBROOTLINKS64)

$(CONS32)lint: lintcheck
$(CONS64)lint: strictlintcheck64

$(ROOTETC)/%:	../common/%
	$(INS.file)

include $(SRC)/lib/Makefile.targ
