#
# Copyright (c) 2008, 2015, Oracle and/or its affiliates. All rights reserved.
#

#
# CStyle, wrap the cstyle tool in a pythonic API
#

import sys
from onbld.Checks.ProcessCheck import processcheck


def cstyle(fh, filename=None, output=sys.stderr, **opts):
    opttrans = {
        "check_continuation": "-c",
        "heuristic": "-h",
        "picky": "-p",
        "verbose": "-v",
        "ignore_hdr_comment": "-C",
        "check_posix_types": "-P",
        "doxygen_comments": "-odoxygen",
        "splint_comments": "-osplint"}

    for x in [x for x in opts if x not in opttrans]:
        raise TypeError("cstyle() got an unexpected keyword argument %s" % x)

    options = [opttrans[x] for x in opts if opts[x]]

    if not filename:
        filename = fh.name

    ret, tmpfile = processcheck("cstyle", options, fh, output)

    if tmpfile:
        for line in tmpfile:
            line = line.replace("<stdin>", filename)
            output.write(line)

        tmpfile.close()
    return ret
