#
# Copyright (c) 2013, 2015, Oracle and/or its affiliates. All rights reserved.
#

#
# JSStyle, wrap the jsstyle tool in a pythonic API
#

import sys
from onbld.Checks.ProcessCheck import processcheck


def jsstyle(fh, filename=None, output=sys.stderr, **opts):
    opttrans = {
        "check_continuation": "-c",
        "heuristic": "-h",
        "indent_space": "-ispace",
        "indent_tab": "-itab",
        "verbose": "-v",
        "tabstop_2": "-t2",
        "tabstop_4": "-t4",
        "tabstop_6": "-t6",
        "tabstop_8": "-t8",
        "tabstop_10": "-t10",
        "doxygen_comments": "-odoxygen",
        "splint_comments": "-osplint"
    }

    for x in [x for x in opts if x not in opttrans]:
        raise TypeError("jsstyle() got an unexpected keyword argument %s" % x)

    options = [opttrans[x] for x in opts if opts[x]]

    if not filename:
        filename = fh.name

    ret, tmpfile = processcheck("jsstyle", options, fh, output)

    if tmpfile:
        for line in tmpfile:
            line = line.replace("<stdin>", filename)
            output.write(line)

        tmpfile.close()
    return ret
