#
# Copyright (c) 2008, 2015, Oracle and/or its affiliates. All rights reserved.
#

#
# JStyle, wrap the jstyle tool in a pythonic API
#

import sys
from onbld.Checks.ProcessCheck import processcheck


def jstyle(fh, filename=None, output=sys.stderr, **opts):
    opttrans = {
        "check_continuation": "-c",
        "heuristic": "-h",
        "picky": "-p",
        "ignore_hdr_comment": "-C",
        "verbose": "-v",
        "tabs": "-t"}

    for x in [x for x in opts if x not in opttrans]:
        raise TypeError("jstyle() got an unexpected keyword argument %s" % x)

    options = [opttrans[x] for x in opts if opts[x]]

    if not filename:
        filename = fh.name

    ret, tmpfile = processcheck("jstyle", options, fh, output)

    if tmpfile:
        for line in tmpfile:
            line = line.replace("<stdin>", filename)
            output.write(line)

        tmpfile.close()

    return ret
