#!/usr/bin/python

#
# Copyright (c) 2020, Oracle and/or its affiliates.
#

#
# Check that file is in UTF-8
#

import codecs
import sys


def utf8chk(fh, filename=None, verbose=False, output=sys.stderr):
    if filename:
        name = filename
    else:
        name = fh.name

    try:
        f = codecs.open(name, encoding='utf-8', errors='strict').readlines()
    except UnicodeDecodeError:
        output.write("%s is not in UTF-8 or ASCII" % name)
        return 1

    return 0
