#
# Copyright (c) 2008, 2019, Oracle and/or its affiliates. All rights reserved.
#

include $(SRC)/tools/Makefile.tools
PYVERSION = $(ONBLD_PYVERSION)
include $(SRC)/Makefile.python

.KEEP_STATE_FILE:	$(BUILDDIR)/.make.state.$(MACH)

SRCDIR = ..

PYMODULES =	__init__.py \
		cdm.py
ROOTPYMODDIR =	$(ONBLD_LIBPY)/onbld/hgext

include $(SRC)/Makefile.python.targ

#
# Becasue cdm.py is called from inside Mercurial, we don't get the chance to
# set up the Python sys.path first. Therefore cdm.py does some path fiddling
# before importing the onbld.* modules. This leads to E402, which we suppress
# here, keeping the global W504 set in Makefile.master
#
PEP8_ARGS = --ignore=W504,E402

#
# Python 3 pylint: Until Mercurial ships python 3 modules, pylint flags up
# import errors.
#
# Python 2 pylint: Because multiple versions of Mercurial are supported using
# Version.at_least() and friends, pylint gets confused about the legacy
# mercurial module imports. We could fix this by only supporting a single
# version, but that makes upgrading Mercurial harder. Instead, we (reluctantly)
# turn off pylint. Sigh.
#
DO_PYLINT = no
