#
# Copyright (c) 2009, Oracle and/or its affiliates. All rights reserved.
#

$HG clone -q $BASEWS $REPOS/reparent-ws
cd $REPOS/reparent-ws

fail() {
	print -u2 "$@"
	exit 255
}

reparent() {
	$HG reparent $1 || fail "Reparent to $1 failed"
	[[ $($HG path default) == $1 ]] || \
	    fail "Parent mismatch $1 v. $($HG path default)"
}

reparent $PWD/cadtest-foo
reparent $BASEWS

rm .hg/hgrc
reparent $PWD/no-hgrc

cp /dev/null .hg/hgrc
reparent $PWD/empty-hgrc

cat <<EOF > .hg/hgrc
[paths]
default = /foo/bar/baz
  continued 
  onto
  more
  lines
EOF
reparent $PWD/continuation-lines

# Make sure the continued bits were removed
(( $(wc -l .hg/hgrc | awk '{print $1}') == 3 )) || exit 254

cat <<EOF >.hg/hgrc
[paths]
default = foo
bar = baz

[other-section]
default = test test

EOF
reparent $PWD/other-default
[[ $(sed -ne 6p .hg/hgrc) == "default = test test" ]] || exit 255
