#
# Copyright (c) 2010, 2016, Oracle and/or its affiliates. All rights reserved.
#

#
# Recommit with the active list over only the only outgoing head
# should work, regardless of the number of other outgoing heads.
#
# If the active list represents any non-outgoing head, recommit should
# fail.
#
# tst.simple_branch1.ksh confirms that workspaces with multiple
# outgoing heads or branches will still fail.
# 

#
# The simple-branch workspace already contains two branches, revs 1
# and 2.  We must clone it, such that its extant branches are
# non-outgoing
#
$HG clone -q $REPOS/simple-branch $REPOS/reciable-branch
cd $REPOS/reciable-branch

#
# Create a new, 3rd head, the only outgoing head.
#
$HG up -C 0
echo "change me" >> a
$HG ci -qm "Commit"
NEWHEAD=$($HG id -nr tip)

#
# Try to recommit the first non-outgoing head.  Should fail as the
# active list will contain no changesets.
#
$HG up -C 1
$HG reci -ym "Recommit head 1" && exit 253

#
# Try to recommit the second non-outgoing head.  Should also fail.
#
$HG up -C 2
$HG reci -ym "Recommit head 2" && exit 254

#
# Recommit the only outgoing head, this should work.
#
$HG up -C $NEWHEAD
ksh $HARNESSDIR/tst/recommit/compare_reci.ksh $REPOS/reciable-branch
